/**************************************/
/*   Z-Buffer Drawing Program         */
/*   with Linear Texture Mapping      */
/*   During Polygon Filling Spans     */
/*                                    */
/*   (c) Victor L. Miller   April 1998*/
/*                                    */
/*   Use Z-Buffer and Frame-Buffer    */
/*   For Visible Surface Determination*/
/*   Apply Linear Texture Mapping     */
/*   During Polygon Filling Spans.    */
/*                                    */
/*   Associate Each Vertex or Corner  */
/*   Of The Individual Polygons Which */
/*   Describe A 3-D Object's Surfaces */
/*   With A Corresponding U,V Corner  */
/*   Of A Texture Map Bitmap Pattern. */
/*                                    */
/*   Then Use Linear Interpolation    */
/*   Down The Edges And Across The    */
/*   Spans in U,V Coordinates To      */
/*   Determine Which Texel Of The     */
/*   Texture Map To Select To Obtain  */
/*   The Pixel Color To Transfer To   */
/*   The Drawn Polygon During Polygon */
/*   Filling Spans.                   */
/**************************************/
/**************************************/
/*   Use Surface Normals and Dot      */
/*   Product With Light Source Vector */
/*   To Determine Illumination On     */
/*   Each Face                        */
/*   Compute One Normal For Each      */
/*   Vertex By Averaging Normals      */
/*   From Each Face Which Shares      */
/*   That Common Vertex               */
/*   Perform Interpolated Shading     */
/*   By Computing an Intensity Value  */
/*   At Each Vertex Of A Polygon      */
/*   And Interpolate During The       */
/*   Polygon Span Filling Operation.  */
/*   Gouraud Interpolated Shading     */
/**************************************/
/**************************************/
/*    3-D OBJECT DRAWING PROGRAM      */
/*    V. MILLER  March 1998           */
/*    3-D PROJECTION DRAWING PROGRAM  */
/*                                    */
/*    DEPTH SORT FOR HIDDEN POLYGONS  */
/*                                    */
/*    READS *._3D FILES WHICH ARE     */
/*    ASCII VERSIONS OF BINARY *.3DS  */
/*    FILES                           */
/*                                    */
/*    *.3DS FILES ARE CONVERTED TO    */
/*    ASCII *._3D FILES WITH PROGRAM  */
/*    3DSRDR.C FROM FINLAND (x2ftp)   */
/**************************************/
/**************************************/
/*    USE SETUP OF CUSTOM PALETTE     */
/*    TO PREPARE FOR SHADING GRAPHICS */
/*                                    */
/*    with Super VGA SVGA MODES       */
/*      1024 x 768 x 256 COLOR MODE   */
/*       800 x 600 x 256 COLOR MODE   */
/*       640 x 480 x 256 COLOR MODE   */
/*       640 x 400 x 256 COLOR MODE   */
/*       320 x 200 x 256 COLOR MODE   */
/*                                    */
/**************************************/
/**************************************/
/*    Use Cross Product of Polygon    */
/*    Edges To Determine Surface      */
/*    Normals                         */
/*                                    */
/*    Use Dot Product of Surface      */
/*    Normal With Light Source        */
/*    Unit Direction Vector To        */
/*    Determine Illumination Level    */
/*    On Each Face                    */
/*                                    */
/*   Compute One Normal For Each      */
/*   Vertex By Averaging Normals      */
/*   From Each Face Which Shares      */
/*   That Common Vertex               */
/*   Perform Interpolated Shading     */
/*   By Computing an Intensity Value  */
/*   At Each Vertex Of A Polygon      */
/*   And Interpolate During The       */
/*   Polygon Span Filling Operation.  */
/*   Gouraud Interpolated Shading     */
/*                                    */
/**************************************/
#include <dos.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <graphics.h>      /* Borland BGI - requires driver file EGAVGA.BGI */
#include <alloc.h>
#include <bios.h>
#include <process.h>
/* #include "svgautil.h" */
/* #include "svga256.h"  */
int graphics_driver,graphics_mode;
int ixpt,iypt,ipen,i,ipl,npl,iv,ivert,j,k,p,istyle,ixtxt,iytxt;
int nvert,nplate,npvert,nfaces,aa,bb,cc,icolor,itemp;
int inumplate,inumvertice,istartplate,index,npoints,npplate;
int imatch, inumshared;
int map_width, map_height, i_spin, i_end_flag;
float xavg,yavg,zavg;
float zdepth;
int face_color[575], vertex_intensity[320];
int far texture_map1[64][64];                 /* Use far keyword to get individual 64 K segment for each array */
int far texture_map2[64][64];
int far texture_map3[64][64];
int far texture_map4[64][64];
int far texture_map5[64][64];
int far texture_map6[64][64];
int far texture_map7[64][64];
int far texture_map8[64][64];
int ff,pp,ver,u,v,itext, jp;
int texture_data[5][60], ntextures;
float vertex_normal[3][320];
float scicon,pilotx,piloty,pilotz,vertex[3][320],faces[3][575];
float x,y,z,cgx,cgy,cgz;
double xx,yy,zz;
float xa=0.,ya=0.,za=0.;
float xmax,xmin,ymax,ymin,zmax,zmin,xspread,yspread,zspread,spread;
float xmiddle,ymiddle,zmiddle;
float r1=0.,r2=0.,r3=0.;
float sr1=0., sr2=0., sr3=0.;
float cr1=0., cr2=0., cr3=0.;
float rd1=0,rd2=0,rd3=0;
int hertz=100, duration=10000;
float movex=0.,movey=0.,movez=300.;
float sx=0.,sy=0.;
float sxavg,syavg,sxstart,systart,sxseed,syseed,angle_from_start;
float sxa=0., sya=0., sxb=0., syb=0., szb;
float pi=3.141592, d=1200.,a;
float angle,range,radius,xcenter,ycenter,xpt,ypt,xout,yout,xin,yin;
int   iloop, iloop2, iswapflag=1, ipoint, iface;
int   isection, j_level, icase, ibypass, jj;
int iplate_a,iplate_b,iplate_c;
int zin,zout,c;
char string[80],string_value[4],str_pointer;
int istring_start,ivalue,ivert,ix,iy,iz;
float tempiplate, tempzdepth, mag, dot__product, cos_theta;
int ispan, istep, ispanstep, idrawflag;
float dx1, dx2, dz1, dz2, dzstep, zlow, zhgh, zdepth, zlow_hold, zhgh_hold;
float dintensity, dintensity1, dintensity2;
float du1, du2, dv1, dv2, dustep, dvstep;
int    xlow, xhgh, xlow_hold, xhgh_hold, yhgh_hold, 
       intensity_low, intensity_hgh, intensity_now, 
       intensitylow_hold, intensityhgh_hold,
       ulow, uhgh, vlow, vhgh, ulow_hold, uhgh_hold,
       vlow_hold, vhgh_hold, u_now, v_now;

typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned long  dword;
byte data;

typedef struct { int    x, y, z ; } point3d;
typedef struct { int    x, y, z, pattern, u, v; } point6d;
typedef struct { float fx,fy,fz ; } float3d;
point3d triangle[3], point3d_one, point3d_two, point3d_three, point3d_temp;
float3d tri_face[3], edge_1,edge_2,normal,current_face_normal,light_source_spot,
		     light_source_normal, current_vertex_normal,
		     float3d_one, float3d_two, float3d_three, float3d_temp;
point6d tri6d_face[3], point6d_one, point6d_two, point6d_three, point6d_temp;

unsigned char far frame_buffer [640][50];       /* Frame Buffer For Pixel Color Values */
						/* Unsigned Char Is One Byte Per Location  = 64 K Array */
						/* With Unsigned Char Can Go To [640][100] = 64 K Array */
/*int           far frame_buffer [640][50]; */  /* Frame Buffer For Pixel Color Values */
						/* Integer Is Two Bytes Per Location   */
float far   z_buffer [640][25];      /*     Z-Buffer For Pixel Depth Values */
float far   z_buffer2[640][25];      /*     Z-Buffer For Pixel Depth Values */
				     /* Use far keyword to get individual   */
				     /* 64 K segment for arrays             */
int t1=0,t2=0,p1=0;
char dummy,buffer[80];

typedef struct tagBITMAP            /* the structure for a bitmap */
{
  dword width;
  dword height;
  byte *data;
} BITMAP;
  BITMAP bmp;

/* typedef struct{                    */  /* rgbvalue for creating palette */
/*    unsigned char red, green, blue; */
/* } rgbvalue;                        */

/* typedef rgbvalue VGApalette[256];  */ /* 256 colors rgbvalue storage */ /*VGApalette[] is a typedef */
/* VGApalette pal;                    */ /* pal is the actual storage array which is of type VGApalette*/

void keyboard_input(void);
/* int huge DetectVGA256()   */
/* {                         */
/*  int Vid;                 */

/*  printf("Which video mode would you like to use? \n");   */
/*  printf("  0) 320x200x256\n");                           */
/*  printf("  1) 640x400x256\n");                           */
/*  printf("  2) 640x480x256\n");                           */
/*  printf("  3) 800x600x256\n");                           */
/*  printf("  4) 1024x768x256\n");                          */
/*  printf("  5) 640x480x256\n");                           */
/*  printf("  6) 1280x1024x256\n");                         */
/*  printf("\n> ");                                         */
/*  scanf("%d",&Vid);                                       */
/*  Vid=2;              */        /* Force mode 2 =   640 x 480 x 256 colors */
/*  return Vid;         */
/*  }                   */

/* palette handling */
/* void VGAsetpalette(VGApalette p)         */
/*  {                                       */
/*     union REGS inregs, outregs;          */
/*     struct SREGS segregs;                */

/*     inregs.x.ax = 0x1012;                */
/*     inregs.x.bx = 0;                     */
/*     inregs.x.cx = 256;                   */
/*     segregs.es = FP_SEG(p);              */
/*     inregs.x.dx = FP_OFF(p);             */

/* DOS interupt rountine 16 is for video functions  */
/*    int86x(0x10, &inregs, &outregs, &segregs);    */
/*    }                                             */

FILE *fp;
void keyboard(void);
void keyboard_input(void);
void keyboard_esc(void);
void calc_3d(void);
void rotation(void);
void vic_sort(void);
float maximum(float x,float y);
float minimum(float x,float y);
void calc_normal(void);
void dot_product(void);
void lambert(void);
void display_palette_colors(void);
void display_lighting_model(void);
void display_text_maps(void);
void polyfill_vic_linear_texturemap(void);
void load_bmp(char *file,BITMAP *bmp);
void draw_bmp(BITMAP *bmp);
void draw_bmp2(BITMAP *bmp);
void draw_bmp3(BITMAP *bmp);
void draw_bmp4(BITMAP *bmp);
void draw_bmp5(BITMAP *bmp);
void draw_bmp6(BITMAP *bmp);
void draw_bmp7(BITMAP *bmp);
void draw_bmp8(BITMAP *bmp);

main()
{
	fp=fopen("eng3dtxt.vlm","r");       /* open icon file */
/*      printf("Opened File \n");   */
	ipoint=0;
	iface=0;
	while(feof(fp) == 0) {              /* read until End-Of-File is reached */
/*      fread(&string,80,1,fp);  */         /* read line as string */
	fgets(string,80,fp);                /* read line from file as string */
/*      for(i=1;i<=80;i++) {
	printf("%c",string[i-1]); }  */

	istring_start=0;
	str_pointer=strstr(string,"Vertices:");
	if(str_pointer!=NULL) {
/*      printf("Vertices: found at position %i \n",str_pointer);
	for(i=1;i<=80;i++) {printf("%c",string[i-1]);}
	keyboard();                                      */
	sscanf(string,"%*s%d",&nvert);
/*      printf("The number of verticies assigned is %i \n",nvert); */
	str_pointer=NULL;
/*      keyboard();        */                         }

	str_pointer=strstr(string,"X:");
	if(str_pointer!=NULL) {
/*      printf("Found X: Y: Z: Data \n");
	for(i=1;i<=80;i++) {printf("%c",string[i-1]);}    */
/*      sscanf(string,"%*s%f, %*s%f, %*s%f\n",&x,&y,&z);  */
	sscanf(string,"              X: %f, Y: %f, Z: %f",&x,&y,&z);
	vertex[0][ipoint]=x;
	vertex[1][ipoint]=y;
	vertex[2][ipoint]=z;
	ipoint=ipoint+1;

	xmax=maximum(xmax,x);                  /* find x,y,z mins and maxs for scaling */
	xmin=minimum(xmin,x);
	ymax=maximum(ymax,y);
	ymin=minimum(ymin,y);
	zmax=maximum(zmax,z);
	zmin=minimum(zmin,z);

/*      for(j=1;j<=ivert;j++) {
	fscanf(fp,"%*s%d%*s%d%*s%d \n",&x,&y,&z);   */
/*      printf("Assigned X: %f Y: %f Z: %f \n",x,y,z); */
	str_pointer=NULL;
	/* keyboard(); */   }

	str_pointer=strstr(string,"Faces:");
	if(str_pointer!=NULL) {
/*      printf("Found Face Number \n");        */
	sscanf(string,"%*s%d",&nfaces);
/*      printf("The number of faces is %i \n",nfaces);   */
	str_pointer=NULL;
/*      keyboard();        */    }

	str_pointer=strstr(string,"A:");
	if(str_pointer!=NULL) {
/*      printf("Found Face Data \n");      */
	sscanf(string,"      A: %i, B: %i, C: %i,%i",&aa,&bb,&cc,&icolor);
	faces[0][iface]=aa;
	faces[1][iface]=bb;
	faces[2][iface]=cc;
	face_color[iface]=icolor;
	iface=iface+1;

	printf("Assigned Face A: %i B: %i C: %i D: %i \n",aa,bb,cc,icolor);
	str_pointer=NULL;
	/* keyboard(); */           }

	str_pointer=strstr(string,"Textures:");
	if(str_pointer!=NULL) {
/*      printf("Found Texture Patterns \n");                   */
	sscanf(string,"%*s%d",&ntextures);
	printf(" \n");
	printf("The number of textures is %i \n",ntextures);
	str_pointer=NULL;
/*      keyboard();        */    }

	str_pointer=strstr(string,"F:");
	if(str_pointer!=NULL) {
/*      printf("Found Face Data \n");      */
	sscanf(string,"      F: %i, P: %i, Vertex: %i, U: %i, V: %i",&ff,&pp,&ver,&u,&v);
	texture_data[0][itext]=ff;
	texture_data[1][itext]=pp;
	texture_data[2][itext]=ver;
	texture_data[3][itext]=u;
	texture_data[4][itext]=v;
	itext=itext+1;

	printf("Found Texture Data F: %i P: %i Vertex: %i U: %i V: %i \n",ff,pp,ver,u,v);
	str_pointer=NULL;
	/* keyboard(); */           }

				  }               /* End-Of-File */
/*      printf("Finished Reading Object File");
	keyboard();                             */
	xspread=xmax - xmin;                      /* Find biggest spread in x,y,z */
	yspread=ymax - ymin;
	zspread=zmax - zmin;
	spread=maximum(xspread,yspread);
	spread=maximum(spread,zspread);
	cgx=(xmax+xmin)/2.;
	cgy=(ymax+ymin)/2.;
	cgz=(zmax+zmin)/2.;
	if(xmin<0) xmin=xmin-1;
	if(ymin<0) ymin=ymin-1;
	if(zmin<0) zmin=zmin-1;
/*      printf("The spreads are: T%f  X%f  Y%f  Z%f \n",
		spread,xspread,yspread,zspread);
	keyboard();                                   */

/*      keyboard();                                   */

						   /* Specify Light Source Location */
	light_source_spot.fx=   0.;
	light_source_spot.fy=-100.;
	light_source_spot.fz=   0.;
	mag=sqrt((light_source_spot.fx*light_source_spot.fx) +
		 (light_source_spot.fy*light_source_spot.fy) +
		 (light_source_spot.fz*light_source_spot.fz));
	light_source_normal.fx=light_source_spot.fx/mag;         /* Determine Direction Vector of Light Source */
	light_source_normal.fy=light_source_spot.fy/mag;
	light_source_normal.fz=light_source_spot.fz/mag;
	printf(" \n");
	printf("Light Source Normal Data X=%f Y=%f Z=%f Mag=%f \n",
		light_source_normal.fx,light_source_normal.fy,light_source_normal.fz,mag);

	printf(" \n");
	printf("Calculating Vertex Normals As Average Of Neighbors \n");
	for(npl=1; npl<=nvert; npl++) {             /* loop through each vertex */
	xavg=0.;                                    /* Each Vertex Normal Is An Average From Neighboring Faces */
	yavg=0.;
	zavg=0.;
	inumshared=0;

	for(ipl=1; ipl<=nfaces; ipl++) {             /* read sequence of faces to be drawn */
	inumplate=ipl-1;                             /* step through each face           */
						     /* gather info for face to be drawn */
						     /* 0= A vertex for plate        */
						     /* 1= B vertex for plate        */
						     /* 2= C vertex for plate        */

	imatch=0;                                    /* Match flag to see if this face shares the current vertex */
	npoints=3;
	for(k=1; k<=npoints; k++) {                   /* visit every vertice which makes up plate to be drawn */
	npplate=npplate+1;                            /* count points which make up each plate                */
	inumvertice=faces[k-1][inumplate];            /* pick-up vertex numbers sequentially for this face */
	
	if(inumvertice==(npl-1)) imatch=1;            /* Test to see if this face shares the current vertex */
	x=vertex[0][inumvertice];                     /* pick-up x,y,z for this vertice  */
	y=vertex[1][inumvertice];
	z=vertex[2][inumvertice];
	float3d_temp.fx=x;
	float3d_temp.fy=y;
	float3d_temp.fz=z;
	tri_face[k-1]=float3d_temp;

				    }                 /* close vertex loop for each face */

	calc_normal();                                /* Compute Surface Normal from Cross Product of Polygon Edges */


	if(imatch==1) { inumshared=inumshared + 1;
			xavg=xavg + normal.fx;
			yavg=yavg + normal.fy;
			zavg=zavg + normal.fz; }   
						       }  /* close face loop for finding all faces sharing this vertex */
	 if(inumshared==0) inumshared=1;
	 vertex_normal[0][npl-1]=xavg/(1.*inumshared);
	 vertex_normal[1][npl-1]=yavg/(1.*inumshared);
	 vertex_normal[2][npl-1]=zavg/(1.*inumshared);

	current_vertex_normal.fx=vertex_normal[0][npl-1];
	current_vertex_normal.fy=vertex_normal[1][npl-1];
	current_vertex_normal.fz=vertex_normal[2][npl-1];

	
	dot_product();                  /* Perform dot product between   */
					/* current_vertex_normal and     */
					/* light_source_normal           */
					/* Since both vectors have Mag=1 */
					/* Dot product is COS (Theta)    */
	cos_theta=dot__product;

					/* Lambert Lighting Model        */
					/*                               */
					/* I = a + b*cos(theta)          */
					/*                               */
					/*     a = ambient light coefficient    */
					/*     b = aspect dependent coefficient */
	lambert();

	printf("Vertex # = %i   Cos(Theta) = %f    Intensity = %i \r",
	       npl-1,cos_theta,ipen);  
	       
	vertex_intensity[npl-1]=ipen;      /* Store the Vertex Intensity */

					}  /* close vertex loop */

	  /*  read in bitmap file   */
	  printf(" \n");
	  printf("Loading Texture Map Patterns From Bitmap Files \n");
	  printf(" \n");
	  printf("Loading Texture Map #1 : \n");
	  load_bmp("rocket.bmp", &bmp);                   /* open the bmp file */
	  draw_bmp(&bmp);
	  printf(" \n");
	  printf("Loading Texture Map #2 : \n");
	  load_bmp("moonface.bmp", &bmp);                 /* open the bmp file */
	  draw_bmp2(&bmp);
	  printf(" \n");
	  printf("Loading Texture Map #3 : \n");
	  load_bmp("guyface.bmp", &bmp);                  /* open the bmp file */
	  draw_bmp3(&bmp);
	  printf(" \n");
	  printf("Loading Texture Map #4 : \n");
	  load_bmp("cycle.bmp", &bmp);                   /* open the bmp file */
	  draw_bmp4(&bmp);
	  printf(" \n");
	  printf("Loading Texture Map #5 : \n");
	  load_bmp("arches.bmp", &bmp);                  /* open the bmp file */
	  draw_bmp5(&bmp);
	  printf(" \n");
	  printf("Loading Texture Map #6 : \n");
	  load_bmp("king.bmp", &bmp);                    /* open the bmp file */
	  draw_bmp6(&bmp);
	  printf(" \n");
	  printf("Loading Texture Map #7 : \n");
	  load_bmp("lion.bmp", &bmp);                    /* open the bmp file */
	  draw_bmp7(&bmp);
	  printf(" \n");
	  printf("Loading Texture Map #8 : \n");
	  load_bmp("vic_seal.bmp", &bmp);                /* open the bmp file */
	  draw_bmp8(&bmp);
	  printf(" \n");

/*        installuserdriver("Svga256",DetectVGA256); */    /* install Super VGA 256 Color Driver */
							   /* 2 = 640 x 480 x 256 colors */
/*        graphics_driver=DETECT;                    */    /* select desired driver and mode */
	  graphics_driver=EGA;                             /* Borland BGI graphics - graphics.h  requires driver file EGAVGA.BGI */
	  graphics_mode=EGAHI;                             /* EGA, EGAHI for paging 640 x 350 x 16 colors    VGA, VGAHI 640 x 480 x 16 colors */
	  initgraph(&graphics_driver, &graphics_mode, ""); /* invoke video mode */

	  /* Initialize a palette with shades red, green, blue */
	  /* for (i=0; i<256; i++) {           */      /* loop through all 256 colors */
	  /* pal[i].red   = i/4;               */      /* red    0 - 63 */
	  /* pal[i].green = i/4;               */      /* green  0 - 63 */
	  /* pal[i].blue  = i/4;     }         */      /* blue   0 - 63 */

	 /* Issue an interupt to change the palette */
	 /* VGAsetpalette(pal);                     */
	 
	cleardevice();
/*      printf(" Bitmap Width  = %i \n",map_width);   */
/*      printf(" Bitmap Height = %i \n",map_height);  */

	settextstyle(3,0,3);
	setcolor(11);
	outtextxy(90, 30, "Z-Buffer Processing  with");
	outtextxy(90, 52, "Linear Texture Mapping   ");
	outtextxy(90, 74, "During Polygon Filling Spans  .  .  .");

	movez=1200.;
	rd1=0; rd2=0; rd3=0;
				/* Starting Orientations : */
	rd1=175.;               /* rd1 = 175.              */
	rd2=-15.;               /* rd1 = 135. or -15.      */
	rd3= 70.;               /* rd3 =  70.              */
	
	for(i_spin=1; i_spin<=57; i_spin++) {               /* Rotate Object in Angular Steps */
							    /* 20 deg steps = 85 steps   30 deg steps = 57 steps */
	if(p==1) { setvisualpage(1);        /* DO DOUBLE-BUFFERING */
	for(j=1; j<=6500; j++) {a=sin(1.);}
		   setactivepage(0);}
	if(p==0) { setvisualpage(0);
	for(j=1; j<=6500; j++) {a=sin(1.);}
		   setactivepage(1);}
	p=1-p;

/*        rd1=rd1+20;   */
	  rd2=rd2+30;           /* Move in one coordinate - spin */ /* angle step size for rotation in degrees */
/*        rd3=rd3+20;   */

	r1=(pi/180.)*rd1;
	r2=(pi/180.)*rd2;
	r3=(pi/180.)*rd3;

	rotation();

	angle_from_start=30*i_spin;                  /* Accumulate Total Angle Rotated From Original Orientation */

							/* Work in sections since z_buffer arrays can not cover all 640 x 480 at once */
/*      for(isection=1; isection<=14; isection++ ) { */ /* Loop through screen sections each 25 pixels high by full 640 in width */
	for(isection=1; isection<= 7; isection++ ) {    /* Loop through screen sections each 25 pixels high by full 640 in width */
							/* Only use those sections which have changes - for speed (Normally full screen height) */
	if(i_spin==1) {                                 /* keep screen active during initialization */
	setactivepage(0);
	outtextxy(76+(25*isection), 172, ".");
	setactivepage(1); }


	for(j=1; j<= 25; j++){                       /* Initialize frame_buffer and z_buffer */
/*      for(i=1; i<=640; i++){     */                /* Step Across Each Screen Line */
	for(i=85; i<=557; i++){                      /* For Speed - Only Initialize Where Image Changes */
	frame_buffer[i-1][j-1]=0;
	frame_buffer[i-1][j-1+25]=0;
	z_buffer    [i-1][j-1]=10000000.;
	z_buffer2    [i-1][j-1]=10000000.;  } }

						     /* NOW DRAW THE THING  */
	for(ipl=1; ipl<=nfaces; ipl++) {             /* read sequence of faces to be drawn */
	inumplate=ipl-1;                             /* step through each face           */
						     /* gather info for face to be drawn */
						     /* 0= A vertex for plate        */
						     /* 1= B vertex for plate        */
						     /* 2= C vertex for plate        */

/*      iplate_a =faces[0][inumplate];           */
/*      iplate_b =faces[1][inumplate];           */
/*      iplate_c =faces[2][inumplate];           */
	ipen=face_color[inumplate];               /* set pen for this plate */
	if(ipen >=15) ipen=10;
	if(ipen <= 0) ipen=10;                    /* make sure pen is visible */
/*      setcolor(ipen);                          */

	npoints=3;
	for(k=1; k<=npoints; k++) {                 /* visit every vertice which makes up plate to be drawn */
	npplate=npplate+1;                          /* count points which make up each plate                */
	inumvertice=faces[k-1][inumplate];          /* pick-up vertex numbers sequentially for this face */


	x=vertex[0][inumvertice];                   /* pick-up x,y,z for this vertice  */
	y=vertex[1][inumvertice];
	z=vertex[2][inumvertice];


	x=(x-cgx)*(375./spread);                    /* normalize and scale object coords */
	y=(y-cgy)*(375./spread);
	z=(z-cgz)*(375./spread);

	if(x==0.) x=.00001;
	if(y==0.) y=.00001;
	if(z==0.) z=.00001;

	calc_3d();                                  /* transform x,y,z  into x,y screen coords */
	sxb=sx+322.;                                /* center object on screen */
	syb=sy+174.;                                /* center object on screen */
	szb=z;
	point3d_temp.x=sxb;
	point3d_temp.y=syb;
	point3d_temp.z=szb;
	triangle[k-1]=point3d_temp;
	point6d_temp.x=sxb;
	point6d_temp.y=syb;
	point6d_temp.z=szb;
	point6d_temp.pattern=0;                    /* default if no texture mapping */
	point6d_temp.pattern=ipen;                 /* default color from object file if no texture mapping */
	point6d_temp.u      =0;                    /* default if no texture mapping */
	point6d_temp.v      =0;                    /* default if no texture mapping */

	for(jp=0; jp<=ntextures-1; jp++) {         /* loop throught texture map data array to find texture map info by face and vertex number */
	if((texture_data[0][jp]==inumplate)&&      /* find texture map info by matching face number and vertex number */
	   (texture_data[2][jp]==inumvertice)) {
	point6d_temp.pattern=texture_data[1][jp];         /* texture pattern number      */
	point6d_temp.u      =texture_data[3][jp];         /* u coordinate on texture map */
	point6d_temp.v      =texture_data[4][jp];
						   } }    /* v coordinate on texture map */

	if((point6d_temp.pattern==107)&&
	   ( ((angle_from_start>= 180)&& (angle_from_start<= 540)) ||
	     ((angle_from_start>= 900)&& (angle_from_start<=1260)) )  )
	   point6d_temp.pattern=104;                  /* Change texture map on alternate rotations of object */
/*      if((point6d_temp.pattern==105)&&                                 */
/*         ( ((angle_from_start>= 540)&& (angle_from_start<= 900)) ||    */
/*           ((angle_from_start>=1260)&& (angle_from_start<=1620)) )  )  */
/*         point6d_temp.pattern=108;                                     */ /* Change texture map on alternate rotations of object */

	tri6d_face[k-1]=point6d_temp;                 /* Transfer 6-D temporary point to triangle 6-D data array */
					 }            /* close vertex loop for each face */
	polyfill_vic_linear_texturemap();             /* Z-Buffer for Visible Surface Determination */
AROUND:
					 }            /* close plate loop   */

/*      j_level=(y_level-1) - (100*(isection-1)); */  /* Translate y-value to buffer addresses */

/*      for(j=1; j<= 10; j++){                    */  /* Assign values to frame_buffer and z_buffer */
/*      for(i=1; i<=640; i++){                    */
/*      frame_buffer[i-1][j-1]=isection%16 ;      */
/*      z_buffer    [i-1][j-1]=1000000.; } }      */

						     /* Draw the frame_buffer */
	for(j=1; j<= 50; j++){                       /* Step Down   Each Screen Line */
/*      for(i=1; i<=640; i++){     */                /* Step Across Each Screen Line */
	for(i=85; i<=557; i++){                      /* For Speed - Only Draw Where Image Changes */
	ipen=frame_buffer[i-1][j-1];
	j_level=(j-1) + (50*(isection-1));           /* Adjust the pixel location for this buffer section */
	putpixel(i-1, j_level, ipen);     } }        /* Draw the pixels from the frame_buffer */

	i_end_flag=0;                               /* re-initialize exit flag */
	keyboard_esc();                             /* get up to 3 key presses */
	keyboard_esc();                             /* get up to 3 key presses */
	keyboard_esc();                             /* get up to 3 key presses */
	if(i_end_flag==1) goto END;                 /* quit only on <ESC> key  */

					    }        /* close section loop */

	setcolor(15);
	settextstyle(0,0,1);
	outtextxy(116,  2,  "Z-BUFFER PROCESSING FOR VISIBLE SURFACE DETERMINATION");
	outtextxy(219, 12,  "     VGA  640 x 480");
	outtextxy( 80, 22,  "                  LINEAR TEXTURE MAPPING ");
	outtextxy( 95, 32,  "APPLY TEXTURE MAP PIXEL PATTERN DURING POLYGON FILLING SPANS ");
	setcolor(15);
	settextstyle(2,0,4);
	outtextxy(474,  337,"(c)  VICTOR L. MILLER  1998");
/*      display_palette_colors(); */
/*      display_lighting_model(); */
	if(i_spin <= 2) display_text_maps();        /* Do Not ReDraw Texture Maps Each Time  - For Speed */
	setcolor(15);
	outtextxy(86,340,  "Press <ESC> to Quit");

					     }      /* close i_spin rotation loop */
END:
/*      getch();          */                        /* hold screen */
	restorecrtmode();                           /* Use when in 256 color mode to restore terminal settings */
						    /* Use when program is to be run from Windows environment  */
	}                                           /* close main() */

/*-------------------------------------------------------------
	SUBROUTINE: CALCULATE SIN, COS FACTORS
   Enter with r1,r2,r3 viewing angles for yaw, roll, pitch
   expressed in radians.  Returns sine and cosine factors.   */

void rotation(void){
sr1=sin(r1); sr2=sin(r2); sr3=sin(r3);
cr1=cos(r1); cr2=cos(r2); cr3=cos(r3); return;}

/*-------------------------------------------------------------
	SUBROUTINE: STANDARD 3D FORMULAS
    Enter with x,y,z cartesian world coordinates.  Returns sx,sy
    cartesian display coordinates.  Returns x,y,z cartesian view
    coordinates which includes rotation and translation effects.  */

void calc_3d(void){
x=(-1)*x; xa=cr1*x-sr1*z; za=sr1*x+cr1*z; x=cr2*xa+sr2*y;
ya=cr2*y-sr2*xa; z=cr3*za-sr3*ya; y=sr3*za+cr3*ya;
x=x+movex; y=y+movey; z=z+movez;
if(z==0.) z=.00001;
sx=d*x/z; sy=d*y/z; return;}

/*-------------------------------------------------------------
	SUBROUTINE: MAXIMUM
   Returns larger of two real numbers                          */

float maximum(float x, float y){
if(x >= y) {return x;};
if(x <= y) {return y;}; }

/*-------------------------------------------------------------
	SUBROUTINE: MINIMUM
   Returns smaller of two real numbers                         */

float minimum(float x, float y){
if(x <= y) {return x;};
if(x >= y) {return y;}; }

/*--------------------------------------------------------------
	SUBROUTINE: KEYBOARD_ESC
							       */
void keyboard_esc(void){
union u_type{int a; char b[3];}keystroke; char inkey=0;

if(bioskey(1)==0) return;                   /* if no key, return      */
keystroke.a=bioskey(0);                     /* fetch ASCII code...    */
inkey=keystroke.b[0];                       /* ... and load code into variable */
switch (inkey) {                            /* make decision based upon ASCII value */
case 27: i_end_flag=1;                      /* set flag to exit on <Esc> key   */
/*case 27: exit(0);   */ /* to exit use exit(0) */
default: return;} }                         /* make routine bullet-proof */


/**************************************************************************
 *      Load_bmp    by  David Brackeen  brackeen@silo.csci.unt.edu        *
 *      Loads a bitmap file into memory.                                  *
 **************************************************************************/

void load_bmp(char *file,BITMAP *bmp)
{
  FILE *fp;
  long index;
  int i,x;

  /* open the file */
  if ((fp = fopen(file,"rb")) == NULL)
  {
    printf("Error opening file %s.\n",file);
    exit(1);
  }

  /* check to see if it is a valid bitmap file */
  if (getc(fp)!='B' || getc(fp)!='M')
  {
    fclose(fp);
    printf("%s is not a bitmap file.\n",file);
    exit(1);
  }

  /* read in the width and height of the image, ignore the rest */
  for(i=0;i<16;i++) x=getc(fp);
  fread(&bmp->width, sizeof(dword), 1, fp);
  fread(&bmp->height,sizeof(dword), 1, fp);
  for(i=0;i<28;i++) x=getc(fp);

  /* try to allocate memory */
  if ((bmp->data = (byte *) malloc((word)(bmp->width*bmp->height))) == NULL)
  {
    fclose(fp);
    printf("Error allocating memory for file %s.\n",file);
    exit(1);
  }

  /* ignore the palette information */
  for(index=0;index<256*4;index++)
    x=getc(fp);

  /* read the bitmap */
  for(index=(bmp->height-1)*bmp->width;index>=0;index-=bmp->width)
    for(x=0;x<bmp->width;x++)
      bmp->data[index+x]=(byte)getc(fp);

  fclose(fp);
  map_width =bmp->width;
  map_height=bmp->height;
}

/**************************************************************************
 *      Draw_bmp                                                          *
 *      Draws a bitmap file                                               *
 **************************************************************************/

void draw_bmp(BITMAP *bmp) {
int i,j;
/*  printf("Bitmap Height = %i \n",bmp->height);  */
/*  printf("Bitmap Width  = %i \n",bmp->width);   */

  for(j=0;j<(bmp->height);j++)  {
  for(i=0;i<(bmp->width) ;i++)
  {
  ipen=bmp->data[(j*(bmp->width))+i];        /* Get the pen color from the bitmap array */
/*putpixel(i+50, j+50, ipen);           */   /* Draw the pixels with the bitmap color   */
  texture_map1[j][i]=ipen;                   /* Load Texture Map Into Array */
   }                           }
   return; }

/**************************************************************************
 *      Draw_bmp                                                          *
 *      Draws a bitmap file                                               *
 **************************************************************************/

void draw_bmp2(BITMAP *bmp) {
int i,j;
/*  printf("Bitmap Height = %i \n",bmp->height);  */
/*  printf("Bitmap Width  = %i \n",bmp->width);   */

  for(j=0;j<(bmp->height);j++)  {
  for(i=0;i<(bmp->width) ;i++)
  {
  ipen=bmp->data[(j*(bmp->width))+i];        /* Get the pen color from the bitmap array */
/*putpixel(i+50, j+50, ipen);           */   /* Draw the pixels with the bitmap color   */
  texture_map2[j][i]=ipen;                   /* Load Texture Map Into Array */
   }                           }
   return; }

/**************************************************************************
 *      Draw_bmp                                                          *
 *      Draws a bitmap file                                               *
 **************************************************************************/

void draw_bmp3(BITMAP *bmp) {
int i,j;
/*  printf("Bitmap Height = %i \n",bmp->height);  */
/*  printf("Bitmap Width  = %i \n",bmp->width);   */

  for(j=0;j<(bmp->height);j++)  {
  for(i=0;i<(bmp->width) ;i++)
  {
  ipen=bmp->data[(j*(bmp->width))+i];        /* Get the pen color from the bitmap array */
/*putpixel(i+50, j+50, ipen);           */   /* Draw the pixels with the bitmap color   */
  texture_map3[j][i]=ipen;                   /* Load Texture Map Into Array */
   }                           }
   return; }

/**************************************************************************
 *      Draw_bmp                                                          *
 *      Draws a bitmap file                                               *
 **************************************************************************/

void draw_bmp4(BITMAP *bmp) {
int i,j;
/*  printf("Bitmap Height = %i \n",bmp->height);  */
/*  printf("Bitmap Width  = %i \n",bmp->width);   */

  for(j=0;j<(bmp->height);j++)  {
  for(i=0;i<(bmp->width) ;i++)
  {
  ipen=bmp->data[(j*(bmp->width))+i];        /* Get the pen color from the bitmap array */
/*putpixel(i+50, j+50, ipen);           */   /* Draw the pixels with the bitmap color   */
  texture_map4[j][i]=ipen;                   /* Load Texture Map Into Array */
   }                           }
   return; }

/**************************************************************************
 *      Draw_bmp                                                          *
 *      Draws a bitmap file                                               *
 **************************************************************************/

void draw_bmp5(BITMAP *bmp) {
int i,j;
/*  printf("Bitmap Height = %i \n",bmp->height);  */
/*  printf("Bitmap Width  = %i \n",bmp->width);   */

  for(j=0;j<(bmp->height);j++)  {
  for(i=0;i<(bmp->width) ;i++)
  {
  ipen=bmp->data[(j*(bmp->width))+i];        /* Get the pen color from the bitmap array */
/*putpixel(i+50, j+50, ipen);           */   /* Draw the pixels with the bitmap color   */
  texture_map5[j][i]=ipen;                   /* Load Texture Map Into Array */
   }                           }
   return; }
/**************************************************************************
 *      Draw_bmp                                                          *
 *      Draws a bitmap file                                               *
 **************************************************************************/

void draw_bmp6(BITMAP *bmp) {
int i,j;
/*  printf("Bitmap Height = %i \n",bmp->height);  */
/*  printf("Bitmap Width  = %i \n",bmp->width);   */

  for(j=0;j<(bmp->height);j++)  {
  for(i=0;i<(bmp->width) ;i++)
  {
  ipen=bmp->data[(j*(bmp->width))+i];        /* Get the pen color from the bitmap array */
/*putpixel(i+50, j+50, ipen);           */   /* Draw the pixels with the bitmap color   */
  texture_map6[j][i]=ipen;                   /* Load Texture Map Into Array */
   }                           }
   return; }
/**************************************************************************
 *      Draw_bmp                                                          *
 *      Draws a bitmap file                                               *
 **************************************************************************/

void draw_bmp7(BITMAP *bmp) {
int i,j;
/*  printf("Bitmap Height = %i \n",bmp->height);  */
/*  printf("Bitmap Width  = %i \n",bmp->width);   */

  for(j=0;j<(bmp->height);j++)  {
  for(i=0;i<(bmp->width) ;i++)
  {
  ipen=bmp->data[(j*(bmp->width))+i];        /* Get the pen color from the bitmap array */
/*putpixel(i+50, j+50, ipen);           */   /* Draw the pixels with the bitmap color   */
  texture_map7[j][i]=ipen;                   /* Load Texture Map Into Array */
   }                           }
   return; }
/**************************************************************************
 *      Draw_bmp                                                          *
 *      Draws a bitmap file                                               *
 **************************************************************************/

void draw_bmp8(BITMAP *bmp) {
int i,j;
/*  printf("Bitmap Height = %i \n",bmp->height);  */
/*  printf("Bitmap Width  = %i \n",bmp->width);   */

  for(j=0;j<(bmp->height);j++)  {
  for(i=0;i<(bmp->width) ;i++)
  {
  ipen=bmp->data[(j*(bmp->width))+i];        /* Get the pen color from the bitmap array */
/*putpixel(i+50, j+50, ipen);           */   /* Draw the pixels with the bitmap color   */
  texture_map8[j][i]=ipen;                   /* Load Texture Map Into Array */
   }                           }
   return; }

/*---------------------------------------------------------
	 SUBROUTINE DISPLAY_TEXT_MAPS                      */

void display_text_maps(void) {

int i,j,ipen;

	settextstyle(2,0,4);
	setcolor(7);
	outtextxy(2,48,"Texture Map 1");
	moveto( 0, 49);
	lineto(79, 49);
	lineto(79,349);
	lineto( 0,349);
	lineto( 0, 49);
	for(j=0;j<map_height;j++)  {
	for(i=0;i<map_width ;i++)  {
	ipen=texture_map1[j][i];                    /* Get the pen color from the bitmap array */
	putpixel(i+7, j+ 59, ipen);                 /* Draw the pixels with the bitmap color   */
				    }  }
	outtextxy(2,123,"Texture Map 2");
	moveto( 0,124);
	lineto(79,124);
	lineto(79,349);
	lineto( 0,349);
	for(j=0;j<map_height;j++)  {
	for(i=0;i<map_width ;i++)  {
	ipen=texture_map2[j][i];                    /* Get the pen color from the bitmap array */
	putpixel(i+7, j+134, ipen);                 /* Draw the pixels with the bitmap color   */
				    }  }
	outtextxy(2,198,"Texture Map 3");
	moveto( 0,199);
	lineto(79,199);
	lineto(79,349);
	lineto( 0,349);
	for(j=0;j<map_height;j++)  {
	for(i=0;i<map_width ;i++)  {
	ipen=texture_map3[j][i];                    /* Get the pen color from the bitmap array */
	putpixel(i+7, j+209, ipen);                 /* Draw the pixels with the bitmap color   */
				    }  }
	outtextxy(2,273,"Texture Map 4");
	moveto( 0,274);
	lineto(79,274);
	lineto(79,349);
	lineto( 0,349);
	for(j=0;j<map_height;j++)  {
	for(i=0;i<map_width ;i++)  {
	ipen=texture_map4[j][i];                    /* Get the pen color from the bitmap array */
	putpixel(i+7, j+284, ipen);                 /* Draw the pixels with the bitmap color   */
				    }  }


	outtextxy(560,48,"Texture Map 5");
	moveto(558, 49);
	lineto(637, 49);
	lineto(637,124);
	lineto(558,124);
	lineto(558, 49);
	for(j=0;j<map_height;j++)  {
	for(i=0;i<map_width ;i++)  {
	ipen=texture_map5[j][i];                    /* Get the pen color from the bitmap array */
	putpixel(i+565, j+ 59, ipen);               /* Draw the pixels with the bitmap color   */
				    }  }
	outtextxy(560,123,"Texture Map 6");
	moveto(558,124);
	lineto(637,124);
	lineto(637,199);
	lineto(558,199);
	lineto(558,124);
	for(j=0;j<map_height;j++)  {
	for(i=0;i<map_width ;i++)  {
	ipen=texture_map6[j][i];                    /* Get the pen color from the bitmap array */
	putpixel(i+565, j+134, ipen);               /* Draw the pixels with the bitmap color   */
				    }  }

	outtextxy(560,198,"Texture Map 7");
	moveto(558,199);
	lineto(637,199);
	lineto(637,274);
	lineto(558,274);
	lineto(558,199);
	for(j=0;j<map_height;j++)  {
	for(i=0;i<map_width ;i++)  {
	ipen=texture_map7[j][i];                  /* Get the pen color from the bitmap array */
	putpixel(i+565, j+209, ipen);             /* Draw the pixels with the bitmap color   */
				    }  }

/*      outtextxy(560,273,"Texture Map 8");  */
/*      moveto(558,274);                     */
/*      lineto(637,274);                     */
/*      lineto(637,349);                     */
/*      lineto(558,349);                     */
/*      lineto(558,274);                     */
/*      for(j=0;j<map_height;j++)  {         */
/*      for(i=0;i<map_width ;i++)  {         */
/*      ipen=texture_map8[j][i];             */     /* Get the pen color from the bitmap array */
/*      putpixel(i+565, j+284, ipen);        */     /* Draw the pixels with the bitmap color   */
/*                                  }  }     */

	return; }

/*---------------------------------------------------------
	 SUBROUTINE LAMBERT
      Lambert Lighting Routine                            */

/* Lambert Lighting Model               */
/*                                      */
/* I = a + b*cos(theta)                 */
/*                                      */
/*     a = ambient light coefficient    */
/*     b = aspect dependent coefficient */

void lambert(void) {
if(cos_theta <= 0.0) {ipen = 0.25*255;/*cos_theta=cos_theta*(-1.);*/ }
		      /*  ipen =  0.25 * 255;     */
if(cos_theta >= 0.0) ipen = (0.25 + (0.75*cos_theta))*255;
return; }
/*---------------------------------------------------------
	 SUBROUTINE DISPLAY_PALETTE
	 SHOW ALL 256 COLORS IN SVGA_256 MODE            */

void display_palette_colors(void) {
int i,j,ipos;
for(i=0; i<=15; i++) {
for(j=0; j<=6;  j++) {
ipos=200 + (6*i) + j;
putpixel(ipos, 349, i);  } }      /* Draw the pixels by pen color number */
return; }

/*---------------------------------------------------------
	 SUBROUTINE DISPLAY_LIGHTING_MODEL
	 SHOW LIGHTING CALCULATION METHOD WITH PICTURE     */

void display_lighting_model(void) {
int i;
setcolor(144);
moveto(30,430);         /* polygon face */
lineto(53,405);
lineto(90,405);
lineto(67,430);
lineto(30,430);
moveto(90,405);         /* vertex normal 1 */
lineto(96,385);
lineto(93,388);
lineto(96,385);
lineto(98,388);
moveto(90,405);
lineto(28,387);
moveto(67,430);         /* vertex normal 2 */
lineto(72,414);
lineto(69,416);
lineto(72,414);
lineto(74,416);
moveto(67,430);
lineto(28,387);
moveto(30,430);         /* vertex normal 3 */
lineto(22,414);
lineto(20,416);
lineto(22,414);
lineto(25,416);
moveto(30,430);
lineto(28,387);
moveto(53,405);         /* vertex normal 4 */
lineto(46,386);
lineto(44,388);
lineto(46,386);
lineto(49,388);
moveto(53,405);
lineto(28,387);
settextstyle(2,0,4);
outtextxy(4,333,"LIGHTING MODEL");
outtextxy(4,342,"GOURAUD INTERPOLATED SHADING");
outtextxy(4,351,"LAMBERT'S LAW :");
outtextxy(4,360,"I = A + B*COS(O)");
outtextxy(2,360,"              - ");
outtextxy(103,380,"VERTEX");
outtextxy(103,389,"NORMALS");
outtextxy(103,398,"AVERAGED");
outtextxy(103,407,"FROM FACES");
outtextxy(103,416,"WHICH SHARE");
outtextxy(103,425,"EACH VERTEX");
outtextxy(3,377,"LIGHT");
outtextxy(3,385,"RAY");
outtextxy(79,387,"O");
outtextxy(79,387,"-");
return; }
/*---------------------------------------------------------
	 SUBROUTINE CALC_NORMAL
     Calculate Surface Normal Routine
     From Vector Cross Product of Face Edges             */

/* Compute Edges From Vertex Differences                 */
/* Surface Normal is Cross Product of Two Edges of Face  */
/* Normal to Vectors A and B           N = A x B         */

/* Determinant of :                  |  i  j  k  |       */
/*                                   |  ax ay az |       */
/*                                   |  bx by bz |       */

void calc_normal(void) {

float3d_one  =tri_face[0];
float3d_two  =tri_face[1];
float3d_three=tri_face[2];
/* printf("Point-1 X=%f Y=%f Z=%f \n",float3d_one.fx,float3d_one.fy,float3d_one.fz);       */
/* printf("Point-2 X=%f Y=%f Z=%f \n",float3d_two.fx,float3d_two.fy,float3d_two.fz);       */
/* printf("Point-3 X=%f Y=%f Z=%f \n",float3d_three.fx,float3d_three.fy,float3d_three.fz); */

edge_1.fx=float3d_one.fx - float3d_two.fx;               /* Compute Edges From Vertex Differences */
edge_1.fy=float3d_one.fy - float3d_two.fy;
edge_1.fz=float3d_one.fz - float3d_two.fz;
edge_2.fx=float3d_three.fx - float3d_two.fx;
edge_2.fy=float3d_three.fy - float3d_two.fy;
edge_2.fz=float3d_three.fz - float3d_two.fz;
normal.fx=(edge_1.fy*edge_2.fz) - (edge_1.fz*edge_2.fy); /* Surface Normal is Cross Product of Two Edges of Face */
normal.fy=(edge_1.fz*edge_2.fx) - (edge_1.fx*edge_2.fz); /* Vectors A and B           N = A x B                  */
normal.fz=(edge_1.fx*edge_2.fy) - (edge_1.fy*edge_2.fx);
							 /* Determinant of :        |  i  j  k  |     */
							 /*                         |  ax ay az |     */
							 /*                         |  bx by bz |     */

mag=sqrt((normal.fx*normal.fx) +                         /* Normalize Direction Vector */
	 (normal.fy*normal.fy) +
	 (normal.fz*normal.fz));


normal.fx = normal.fx / mag;
normal.fy = normal.fy / mag;
normal.fz = normal.fz / mag;
return; }

/*---------------------------------------------------------
	 SUBROUTINE DOT_PRODUCT
     Calculate Dot Product Routine                       */

/* Compute Dot Product Between Two Vectors               */
/*                                                       */
/* Dot Product of two Vectors A and B      P = A . B     */
/*                                                       */
/*                                  A=  ax ay az         */
/*                                  B=  bx by bz         */ 
/*                                                       */
/*       P= ax*bx + ay*by + az*bz                        */
/*                                                       */
/*       P= |A| |B| cos(theta)                           */
/*                                                       */
/*       When A, B unit vectors Magnitude = 1            */
/*       Dot Product is cos(theta)                       */

void dot_product(void) {

dot__product=((light_source_normal.fx*current_vertex_normal.fx) +
	      (light_source_normal.fy*current_vertex_normal.fy) +
	      (light_source_normal.fz*current_vertex_normal.fz)) ;
return; }                                                
							
/*--------------------------------------------------------------
	 SUBROUTINE POLYFILL_VIC_LINEAR_TEXTUREMAP
    Polygon Fill Routine With Depth Value Plane Equation        */

void polyfill_vic_linear_texturemap(void) {

/* setcolor(ipen); */                              /* Set Color of Face     */

point6d_one=tri6d_face[0];
point6d_two=tri6d_face[1];
point6d_three=tri6d_face[2];

						   /* Get All Three Points Ordered By Y-Values */
if(point6d_two.y < point6d_one.y)
{ point6d_temp=point6d_one; point6d_one=point6d_two; point6d_two=point6d_temp;}        /* swap */
if(point6d_three.y < point6d_one.y)
{ point6d_temp=point6d_one; point6d_one=point6d_three; point6d_three=point6d_temp;}    /* swap */
if(point6d_three.y < point6d_two.y)
{ point6d_temp=point6d_two; point6d_two=point6d_three; point6d_three=point6d_temp;}    /* swap */
if(point6d_two.y < point6d_one.y)
{ point6d_temp=point6d_one; point6d_one=point6d_two; point6d_two=point6d_temp;}        /* swap */
if(point6d_three.y < point6d_one.y)
{ point6d_temp=point6d_one; point6d_one=point6d_three; point6d_three=point6d_temp;}    /* swap */
if(point6d_three.y < point6d_two.y)
{ point6d_temp=point6d_two; point6d_two=point6d_three; point6d_three=point6d_temp;}    /* swap */

/*  printf("Subroutine Polyfill_Vic \n");                                                 */
/*  printf("All Three Triangle Points Sorted By Y-Value \n");                             */
/*  printf("X1= %i  Y1= %i   Z1= %i \n",point3d_one.x,point3d_one.y,point3d_one.z);       */
/*  printf("X2= %i  Y2= %i   Z2= %i \n",point3d_two.x,point3d_two.y,point3d_two.z);       */
/*  printf("X3= %i  Y3= %i   Z3= %i \n",point3d_three.x,point3d_three.y,point3d_three.z); */
/*  getch();

/* All three points on a horizontal line */
if(point6d_one.y == point6d_two.y) {
if(point6d_one.y == point6d_three.y) {goto BYPASS ; } }
/* All three points on a vertical line */
if(point6d_one.x == point6d_two.x) {
if(point6d_one.x == point6d_three.x) {goto BYPASS ; } }

icase=0;                                                           /* Start with dx1 < dx2 */
ibypass=0;                                                         /* Used to flag when pt2.y == pt3.y */
if(point6d_one.y == point6d_two.y  ) {xhgh=point6d_one.x; zhgh=point6d_one.z;
				      xlow=point6d_two.x; zlow=point6d_two.z;
				      uhgh=point6d_one.u; vhgh=point6d_one.v;
				      ulow=point6d_two.u; vlow=point6d_two.v;
				      if(point6d_two.x > point6d_one.x) { icase=1;
				      xhgh=point6d_two.x; zhgh=point6d_two.z;
				      xlow=point6d_one.x; zlow=point6d_one.z;
				      uhgh=point6d_two.u; vhgh=point6d_two.v;
				      ulow=point6d_one.u; vlow=point6d_one.v;}     goto SPAN2to3; }
if(point6d_two.y == point6d_three.y) {ibypass=1;                                   goto SPAN1to2; }

SPAN1to2:
/* Compute Span Limits For Vertice 1 to 2        */
/* Compute Span Limit Increment Sizes Per Y Step */
/* Compute Delta-X on Left and Right   Compute Delta-Z on Left and Right */
/* Compute Delta-U on Left and Right   Compute Delta-V on Left and Right */
dx1=(point6d_two.x - point6d_one.x)   / (1.*(point6d_two.y   - point6d_one.y));
dz1=(point6d_two.z - point6d_one.z)   / (1.*(point6d_two.y   - point6d_one.y));
du1=(point6d_two.u - point6d_one.u)   / (1.*(point6d_two.y   - point6d_one.y));
dv1=(point6d_two.v - point6d_one.v)   / (1.*(point6d_two.y   - point6d_one.y));

dx2=(point6d_three.x - point6d_one.x) / (1.*(point6d_three.y - point6d_one.y));
dz2=(point6d_three.z - point6d_one.z) / (1.*(point6d_three.y - point6d_one.y));
du2=(point6d_three.u - point6d_one.u) / (1.*(point6d_three.y - point6d_one.y));
dv2=(point6d_three.v - point6d_one.v) / (1.*(point6d_three.y - point6d_one.y));

if(dx2 < dx1) icase=1;                                             /* Flag cases with    dx2 < dx1  */

if(icase==1) {                                                     /* Reverse Limits for dx2 < dx1  */
dx1=(point6d_three.x - point6d_one.x)   / (1.*(point6d_three.y   - point6d_one.y));
dz1=(point6d_three.z - point6d_one.z)   / (1.*(point6d_three.y   - point6d_one.y));
du1=(point6d_three.u - point6d_one.u)   / (1.*(point6d_three.y   - point6d_one.y));
dv1=(point6d_three.v - point6d_one.v)   / (1.*(point6d_three.y   - point6d_one.y));

dx2=(point6d_two.x - point6d_one.x)     / (1.*(point6d_two.y     - point6d_one.y));
dz2=(point6d_two.z - point6d_one.z)     / (1.*(point6d_two.y     - point6d_one.y));
du2=(point6d_two.u - point6d_one.u)     / (1.*(point6d_two.y     - point6d_one.y));
dv2=(point6d_two.v - point6d_one.v)     / (1.*(point6d_two.y     - point6d_one.y));  }

istep=0;                                                 /* Step Down Polygon One Line At A Time */
for(jj=point6d_one.y; jj<=point6d_two.y; jj++) {         /* Step Down Face in Y */

xlow=point6d_one.x + istep*dx1;                          /* Determine X Span Limits - Low and High */
xhgh=point6d_one.x + istep*dx2;
zlow=point6d_one.z + istep*dz1;                          /* Determine Z Span Limits - Low and High */
zhgh=point6d_one.z + istep*dz2;
ulow=point6d_one.u + istep*du1;                          /* Determine U Span Limits - Low and High */
uhgh=point6d_one.u + istep*du2;
vlow=point6d_one.v + istep*dv1;                          /* Determine V Span Limits - Low and High */
vhgh=point6d_one.v + istep*dv2;

if(xhgh==xlow) {dzstep=0; dustep=0; dvstep=0;}           /* Avoid divide by zero */
if(xhgh!=xlow) {dzstep=(zhgh - zlow) / (1.*(xhgh - xlow));
		dustep=(uhgh - ulow) / (1.*(xhgh - xlow));
		dvstep=(vhgh - vlow) / (1.*(xhgh - xlow)); }

istep=istep+1;

j_level=(jj-1) - (50*(isection-1));            /* Compute Adjusted Y-value for this section */
idrawflag=1;                                   /* Current Y-level within this section range */
if(j_level<0)  idrawflag=0 ;                   /* Do not draw if out of bounds              */
if(j_level>49) idrawflag=0 ;                   /* Do not draw if out of bounds              */

ispanstep=0;
for(ispan=xlow; ispan<=xhgh; ispan ++) {
zdepth=zlow + ispanstep*dzstep;
u_now =ulow + ispanstep*dustep;
v_now =vlow + ispanstep*dvstep;
if(point6d_one.pattern <= 100)  ipen=point6d_one.pattern;         /* If Pattern 1 - 15 use as color  number  */
if(point6d_one.pattern >  100) {if(u_now< 0) u_now= 0;            /* Ensure within bitmap boundary */
				if(u_now> map_width-1)  u_now=map_width-1;  /* Ensure within bitmap boundary */
				if(v_now< 0) v_now= 0;            /* Ensure within bitmap boundary */
				if(v_now> map_height-1) v_now=map_height-1; /* Ensure within bitmap boundary */
				ipen=texture_map1[u_now][v_now];
				if(point6d_one.pattern==102)      /* Choose which bitmap to use */
				ipen=texture_map2[u_now][v_now];
				if(point6d_one.pattern==103)      /* Choose which bitmap to use */
				ipen=texture_map3[u_now][v_now];
				if(point6d_one.pattern==104)      /* Choose which bitmap to use */
				ipen=texture_map4[u_now][v_now];
				if(point6d_one.pattern==105)      /* Choose which bitmap to use */
				ipen=texture_map5[u_now][v_now];
				if(point6d_one.pattern==106)      /* Choose which bitmap to use */
				ipen=texture_map6[u_now][v_now];
				if(point6d_one.pattern==107)      /* Choose which bitmap to use */
				ipen=texture_map7[u_now][v_now];
				if(point6d_one.pattern==108)      /* Choose which bitmap to use */
				ipen=texture_map8[u_now][v_now];
				if(point6d_one.pattern==101) {
				if(ipen==0) ipen=10;                    /* Transparent Bitmap - Set Background Color */
				if(ipen==0) ipen=face_color[inumplate];}/* Transparent Bitmap - Use Background Plate Color */
								}       /* If Pattern > 100  use as bitmap number  */
									/* Get the pen color from the bitmap array */
ispanstep=ispanstep+1;
if(idrawflag==1) {
if(j_level<=24) {
if(zdepth < z_buffer[ispan][j_level]) { frame_buffer[ispan][j_level]=ipen;             /* Compare Depth Z-Value At Each Pixel */
					    z_buffer[ispan][j_level]=zdepth;} }        /* To Determine If Should Draw New Color */
if(j_level>=25) {
if(zdepth < z_buffer2[ispan][j_level-25]) { frame_buffer[ispan][j_level]=ipen;             /* Compare Depth Z-Value At Each Pixel */
					    z_buffer2[ispan][j_level-25]=zdepth;} } } } }  /* To Determine If Should Draw New Color */

if(ibypass==1) goto BYPASS;                                                   /* Bypass For case when pt2.y == pt3.y */

/* Save Intermediate Points After Second Vertice */

SPAN2to3:
xhgh_hold=xhgh;
xlow_hold=xlow;
yhgh_hold=point6d_two.y;
zhgh_hold=zhgh;
zlow_hold=zlow;
uhgh_hold=uhgh;
ulow_hold=ulow;
vhgh_hold=vhgh;
vlow_hold=vlow;

/* Compute New Span Limits For Vertice 2 to 3    */
/* Compute Span Limit Increment Sizes Per Y Step */
/* Compute Delta-X on Left and Right   Compute Delta-Z on Left and Right */
/* Compute Delta-U on Left and Right   Compute Delta-V on Left and Right */
dx1=(point6d_three.x - point6d_two.x)   / (1.*(point6d_three.y - point6d_two.y));
dz1=(point6d_three.z - point6d_two.z)   / (1.*(point6d_three.y - point6d_two.y));
du1=(point6d_three.u - point6d_two.u)   / (1.*(point6d_three.y - point6d_two.y));
dv1=(point6d_three.v - point6d_two.v)   / (1.*(point6d_three.y - point6d_two.y));

dx2=(point6d_three.x - xhgh_hold)       / (1.*(point6d_three.y - point6d_two.y));
dz2=(point6d_three.z - zhgh_hold)       / (1.*(point6d_three.y - point6d_two.y));
du2=(point6d_three.u - uhgh_hold)       / (1.*(point6d_three.y - point6d_two.y));
dv2=(point6d_three.v - vhgh_hold)       / (1.*(point6d_three.y - point6d_two.y));

if(icase==1) {                                                                     /* Reverse Limits for dx2 < dx1 */
dx1=(point6d_three.x - xlow_hold    )   / (1.*(point6d_three.y   - point6d_two.y));
dz1=(point6d_three.z - zlow_hold    )   / (1.*(point6d_three.y   - point6d_two.y));
du1=(point6d_three.u - ulow_hold    )   / (1.*(point6d_three.y   - point6d_two.y));
dv1=(point6d_three.v - vlow_hold    )   / (1.*(point6d_three.y   - point6d_two.y));

dx2=(point6d_three.x - point6d_two.x)   / (1.*(point6d_three.y   - point6d_two.y));
dz2=(point6d_three.z - point6d_two.z)   / (1.*(point6d_three.y   - point6d_two.y));
du2=(point6d_three.u - point6d_two.u)   / (1.*(point6d_three.y   - point6d_two.y));
dv2=(point6d_three.v - point6d_two.v)   / (1.*(point6d_three.y   - point6d_two.y)); }

istep=0;
for(jj=point6d_two.y; jj<=point6d_three.y; jj++) {         /* Step Down Face in Y */

xlow=point6d_two.x + istep*dx1;                            /* Determine X Span Limits - Low and High */
xhgh=xhgh_hold     + istep*dx2;
zlow=point6d_two.z + istep*dz1;                            /* Determine Z Span Limits - Low and High */
zhgh=zhgh_hold     + istep*dz2;
ulow=point6d_two.u + istep*du1;                            /* Determine U Span Limits - Low and High */
uhgh=uhgh_hold     + istep*du2;
vlow=point6d_two.v + istep*dv1;                            /* Determine V Span Limits - Low and High */
vhgh=vhgh_hold     + istep*dv2;

if(icase==1) {                                             /* Compute X Span Limits for dx2 < dx1 */
xlow=xlow_hold     + istep*dx1;
xhgh=point6d_two.x + istep*dx2;
zlow=zlow_hold     + istep*dz1;                            /* Compute Z Span Limits for dx2 < dx1 */
zhgh=point6d_two.z + istep*dz2;
ulow=ulow_hold     + istep*du1;                            /* Compute U Span Limits for dx2 < dx1 */
uhgh=point6d_two.u + istep*du2;
vlow=vlow_hold     + istep*dv1;                            /* Compute V Span Limits for dx2 < dx1 */
vhgh=point6d_two.v + istep*dv2; }

if(xhgh==xlow) {dzstep=0; dustep=0; dvstep=0;}             /* Avoid divide by zero */
if(xhgh!=xlow) {dzstep=(zhgh - zlow) / (1.*(xhgh - xlow));
		dustep=(uhgh - ulow) / (1.*(xhgh - xlow));
		dvstep=(vhgh - vlow) / (1.*(xhgh - xlow)); }

istep=istep+1;

j_level=(jj-1) - (50*(isection-1));            /* Compute Adjusted Y-value for this section */
idrawflag=1;                                   /* Current Y-level within this section range */
if(j_level<0)  idrawflag=0 ;                   /* Do not draw if out of bounds              */
if(j_level>49) idrawflag=0 ;                   /* Do not draw if out of bounds              */

ispanstep=0;
for(ispan=xlow; ispan<=xhgh; ispan ++) {
zdepth=zlow + ispanstep*dzstep;
u_now =ulow + ispanstep*dustep;
v_now =vlow + ispanstep*dvstep;
if(point6d_one.pattern <= 100)  ipen=point6d_one.pattern;         /* If Pattern 1 - 15 use as color  number  */
if(point6d_one.pattern >  100) {if(u_now< 0) u_now= 0;            /* Ensure within bitmap boundary */
				if(u_now> map_width-1)  u_now=map_width-1;  /* Ensure within bitmap boundary */
				if(v_now< 0) v_now= 0;            /* Ensure within bitmap boundary */
				if(v_now> map_height-1) v_now=map_height-1; /* Ensure within bitmap boundary */
				ipen=texture_map1[u_now][v_now];
				if(point6d_one.pattern==102)      /* Choose which bitmap to use */
				ipen=texture_map2[u_now][v_now];
				if(point6d_one.pattern==103)      /* Choose which bitmap to use */
				ipen=texture_map3[u_now][v_now];
				if(point6d_one.pattern==104)      /* Choose which bitmap to use */
				ipen=texture_map4[u_now][v_now];
				if(point6d_one.pattern==105)      /* Choose which bitmap to use */
				ipen=texture_map5[u_now][v_now];
				if(point6d_one.pattern==106)      /* Choose which bitmap to use */
				ipen=texture_map6[u_now][v_now];
				if(point6d_one.pattern==107)      /* Choose which bitmap to use */
				ipen=texture_map7[u_now][v_now];
				if(point6d_one.pattern==108)      /* Choose which bitmap to use */
				ipen=texture_map8[u_now][v_now];
				if(point6d_one.pattern==101) {
				if(ipen==0) ipen=10;                    /* Transparent Bitmap - Set Background Color */
				if(ipen==0) ipen=face_color[inumplate];}/* Transparent Bitmap - Use Background Plate Color */
								}       /* If Pattern > 100  use as bitmap number  */
									/* Get the pen color from the bitmap array */
ispanstep=ispanstep+1;
if(idrawflag==1) {
if(j_level<=24) {
if(zdepth < z_buffer[ispan][j_level]) { frame_buffer[ispan][j_level]=ipen;             /* Compare Depth Z-Value At Each Pixel */
					    z_buffer[ispan][j_level]=zdepth;} }        /* To Determine If Should Draw New Color */
if(j_level>=25) {
if(zdepth < z_buffer2[ispan][j_level-25]) { frame_buffer[ispan][j_level]=ipen;             /* Compare Depth Z-Value At Each Pixel */
					    z_buffer2[ispan][j_level-25]=zdepth;} } } } }  /* To Determine If Should Draw New Color */

BYPASS:
return; }
